<template>
    <div class="q-gutter-y-lg full-width">

        <q-select
            :options="FloorChartType"
            emit-value
            map-options
            label-slot
            filled
            v-model="routeQueries.type">
            <template v-slot:label>
                <LabelSlot icon="icofont-dashboard-web" label="Chart Type"
                           tooltip="The chart to type to visualize the analytics"/>
            </template>

            <template v-slot:option="scope">
                <q-item v-bind="scope.itemProps" v-on="scope.itemEvents">
                    <q-item-section avatar>
                        <q-icon :name="scope.opt.icon"/>
                    </q-item-section>
                    <q-item-section>
                        <q-item-label>
                            {{ scope.opt.label }}
                        </q-item-label>
                    </q-item-section>
                </q-item>
            </template>
        </q-select>
        <q-select
            :options="FloorValueType"
            emit-value
            filled
            map-options
            label-slot
            v-model="routeQueries.valueType">
            <template v-slot:label>
                <LabelSlot icon="icofont-speed-meter" label="Metric"
                           tooltip="The metric used to compute the analytics"/>
            </template>
        </q-select>
        <q-select
            :options="FloorVariable"
            emit-value
            filled
            map-options
            label-slot
            v-model="routeQueries.independent">
            <template v-slot:label>
                <LabelSlot icon="icofont-chart-arrows-axis" label="Graph Axis"
                           tooltip="The axes of data you want to visualize"/>
            </template>
        </q-select>
        <q-select v-model="routeQueries.trades" :options="Trades" label-slot multiple use-chips use-input filled>
            <template v-slot:label>
                <LabelSlot icon="icofont-wrench" label="Worker Trade Filter"
                           tooltip="Filter by trades (leave empty for no filter)"/>
            </template>
        </q-select>
        <q-toggle label="Merge" icon="call_merge" v-model="merge" v-if="ShowMerge"/>
        <q-input filled v-model="stringModel" mask="####/##/## - ####/##/##">
            <template v-slot:append>
                <q-icon name="event" class="cursor-pointer">
                    <q-popup-proxy ref="qDateProxy" transition-show="scale" transition-hide="scale">
                        <q-date v-model="dateModel" range :events="days">
                            <div class="row items-center justify-end">
                                <q-btn v-close-popup label="Close" color="primary" flat/>
                            </div>
                        </q-date>
                    </q-popup-proxy>
                </q-icon>
            </template>
        </q-input>
        <QSelect v-if="routeQueries.type === 'line' || routeQueries.type === 'bar'"
                 filled
                 v-model="routeQueries.scope"
                 label-slot
                 :options="['Hour', 'Day','Month']">
            <template v-slot:label>
                <LabelSlot icon="icofont-clock-time" label="Time Scope"
                           tooltip="How narrow to divide time intervals"/>
            </template>
        </QSelect>
    </div>
</template>

<script lang='ts'>
import {Component, Prop, Vue} from 'vue-property-decorator';
import FormCore from "components/FormCore.vue";
import {FloorChartValueType, FloorChartVariableType, FloorGraphType} from "src/classLibrary/Charting/FloorChart";
import LabelSlot from "components/LabelSlot.vue";


@Component({
    components: {LabelSlot, FormCore}
})
export default class FloorChartOptions extends Vue {
    routeQueries = {
        startTime: '',
        endTime: '',
        trades: [],
        type: '',
        independent: '',
        valueType: '',
        scope: '',
        merge: 'false',
    }

    get ShowMerge() {
        const t = this.routeQueries.type;
        return t !== 'line' && t != 'radar' && t !== 'bar';
    }

    get merge() {
        return this.routeQueries.merge === 'true';
    }

    set merge(m: boolean) {
        this.routeQueries.merge = m ? 'true' : 'false';
    }

    @Prop() days!: string[];

    get FloorChartType() {
        return FloorGraphType;
    }

    get FloorVariable() {
        return FloorChartVariableType;
    }

    Trades: string[] = []

    async init() {
        const projectId = this.PersistentStore.StoreValue.project;
        const token = await this.$auth.CoreToken;
        const r = await this.$coreApi.Get<string[]>(`Worker/trades/${projectId}`, null, token);
        if (r.isErr()) return;
        this.Trades = r.unwrap();
    }


    get FloorValueType() {
        return FloorChartValueType;
    }

    get dateModel(): { from: string, to: string } | string {
        if (this.routeQueries.startTime === this.routeQueries.endTime) {
            return this.routeQueries.startTime;
        }
        return {
            from: this.routeQueries.startTime,
            to: this.routeQueries.endTime,
        }
    }

    get stringModel() {
        return `${this.routeQueries.startTime} - ${this.routeQueries.endTime}`;
    }

    set stringModel(d: string) {
        const [from, to] = d.split('-').Map(x => x.trim());
        this.routeQueries.startTime = from;
        this.routeQueries.endTime = to;
    }

    set dateModel(model: { from: string, to: string } | string) {
        if (model == null) return;
        if ((model as any).from) {
            model = model as { from: string, to: string }
            this.routeQueries.startTime = model.from
            this.routeQueries.endTime = model.to
        } else {
            this.routeQueries.startTime = model as string;
            this.routeQueries.endTime = model as string;
        }
    }
}
</script>

<style lang='scss' scoped>

</style>
